#include "RegisterServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>
#include <sys/resource.h>

int main()
{
	struct rlimit core_limits;
	core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
	setrlimit(RLIMIT_CORE, &core_limits);

    Framework::initFramework();
	Zeit *z = getZeit();
	Text *pfad = new Text( "../log/register/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis() );
	std::ofstream file;
	file.open( pfad->getText() );
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf( file.rdbuf() );
	pfad->release();

	std::cout << "RS: Startet...\n";
	std::cout << "RS: Lese init Datei ../data/rsInit.ini ...\n";
	InitDatei *dat = new InitDatei( "../data/rsInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "RS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
	}
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv", "Java", "Mailer", "PHP", "AccountActivationMail", "SSLCert", "SSLKey", "SSLPasswort" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "RS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

	RegisterServer *rserver = new RegisterServer( dat );

	std::cout << "RS: Der Admin Server läuft. Startforgang beendet.\n";
	rserver->runn();

	rserver->ende();
	rserver->release();
	dat->release();
	std::cout << "RS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
	return 0;
}